#ifndef __MD__
#define __MD__
//
#include <Defines.h>
#include <File.h>
#include <Gauge.h>
#include <Object_factory.h>
#include <Base_problem.h>
#include <Out_message.h>
#include <Error_messager.h>
#include <Vector.h>
//
#include <Base_restart_defines.h>
#include <Problem_component.h>
#include <File.h>
#include <Object_factory.h>
#include <Stringpp.h>
#include <Boundary.h>
#include <Node.h>
#include <List.h>
#include <Set.h>
#include <Problem.h>
#include <Algorithm.h>
#include <Static.h>
#include <Verbose.h>
#include <DD_sub_domain.h>
#include <Message_passing_client.h>
#include <stdlib.h>
#include <Mechanical_mesh.h>
//
#include <Cell.h>
#include <Particle.h>
#include <MD_Integrator.h>
//#include <VerletMethod.h>
#include <MD_Mesh.h>
#include <MD_Potential.h>
#include <MD_Material.h>
#include <MD_BC.h>
#include <MD_Output.h>

namespace ZSET {
  using namespace ZSET;

class MD : public PROBLEM_COMPONENT
{
protected:
    int Np, dim, Nx, Ny, Npx, Npy, Nz,seed,when_write_restart,md_increment, Ntime, itime, time_bc, set_every;
    double cut_off,Sx,Sy,Sz,dt0,dt,T0,md_time,potential_energy,kinetic_energy,displacement, inv_time_bc,tilt,dist_mult,pre_pressure;
    double gamma_temperature;
    bool start_problem,read_from_file;
    //BUFF_LIST<int> mesh;
    STRING input_file, distribution, config; 
    VECTOR rmin,rmax,box;
    BUFF_LIST<double> prescribed_temperature;

    LIST<PARTICLE*> particle;
    ARRAY<CELL*> cell;
    MD_MESH* md_mesh;
    MD_INTEGRATOR* integrator;
    MD_OUTPUT* md_output;
    LIST<MD_MATERIAL*> material;
    MD_POTENTIAL* potential;
    LIST<MD_BC*> bc;
    Zofstream output,output_energy,file_displ_force, tmp_output,output_particles;
    LIST<int> applied_bc0, applied_bc; // TMP, should be moved to MD_BC class
    ARRAY<VECTOR> average_bc0, average_bc;

    GLOBAL_CLIENT gc;
    MP_EXCHANGE mpi_al;

    PROBLEM_STATIC_MECHANICAL *pb;
public:
    MD() : PROBLEM_COMPONENT() {}
    ~MD();

    virtual bool initialize();
    virtual void load(ASCII_FILE& inp, PROBLEM* boss);
    virtual void read_restart(RST_FSTREAM&);
    virtual void write_restart(RST_FSTREAM&);
    virtual void init_problem();
    virtual void start_increment();
    virtual void start_iteration() {}
    virtual void end_iteration() {}

    virtual void md_start_increment();
    virtual void md_end_increment();

    virtual void end_increment(INTEGRATION_RESULT*&) {}
    virtual void end_problem();

    void set_initial_conf() {set_initial_conf("square"); }
    void set_initial_conf(STRING str);
    void set_initial_conf(ASCII_FILE& file) {/*tmp*/ set_initial_conf(); }
    void save_configuration(Zofstream& particle, Zofstream& data) { ERROR("Not implemented yet"); } 

    void define_rmin_rmax();
    void distribute_into_cells(); 
    double get_temperature(double time);
//    void print(Zofstream& file, STRING str);
//    void print_by_color(ARRAY<Zofstream*>& file, STRING str);
    void MaxwellBoltzmanDistribution(double T);
    VECTOR GaussDeviate();
    void update_bc();
    void update_dt() {}
};

}
#endif
