#include <MD_Integrator.h>
#include <Print.h>

using namespace ZSET;


void MD_INTEGRATOR::init(ARRAY<CELL*>& cells) {
  rmin = rmax = cells[0]->r0;
/*
  rmax = rmin;
  for (int i = 0; i < cells.size(); i++) {
    if (cells[i]->r0[0] < rmin[0])
      rmin[0] = cells[i]->r0[0];
    if (cells[i]->r0[1] < rmin[1])
      rmin[1] = cells[i]->r0[1];
    if (cells[i]->r0[0] + cells[i]->size[0] > rmax[0])
      rmax[0] = cells[i]->r0[0] + cells[i]->size[0];
    if (cells[i]->r0[1] + cells[i]->size[1] > rmax[1])
      rmax[1] = cells[i]->r0[1] + cells[i]->size[1];
  }
*/
  rmax = cells[cells.size()-1]->r0 + cells[cells.size()-1]->size;
}

void MD_INTEGRATOR::update_region_bc(ARRAY<MD_BC*> bc) {
  periodic_x = FALSE;
  periodic_y = FALSE;
  periodic_z = FALSE;
  rigid_x_right = FALSE;
  rigid_x_left = FALSE;
  rigid_y_top = FALSE;
  rigid_y_bot = FALSE;
  has_rigid_bc = FALSE;
  for (int ibc = 0; ibc < bc.size(); ibc++)
  {
    if (bc[ibc]->get_type() == PERIODIC_X)
      periodic_x = TRUE;
    else if (bc[ibc]->get_type() == PERIODIC_Y)
      periodic_y = TRUE;
    else if (bc[ibc]->get_type() == PERIODIC_Z)
      periodic_z = TRUE;
    else if (bc[ibc]->get_type() == RIGID_X_RIGHT) {
      rigid_x_right = TRUE;
      has_rigid_bc = TRUE;
    }
    else if (bc[ibc]->get_type() == RIGID_X_LEFT) {
      rigid_x_left = TRUE;
      has_rigid_bc = TRUE;
    }
    else if (bc[ibc]->get_type() == RIGID_Y_TOP) {
      rigid_y_top = TRUE;
      has_rigid_bc = TRUE;
    }
    else if (bc[ibc]->get_type() == RIGID_Y_BOT) {
     rigid_y_bot = TRUE;
      has_rigid_bc = TRUE;
    }
  }
}
/*
void MD_INTEGRATOR::compF(ARRAY<CELL*>& cells, MD_POTENTIAL* pot)
{
    if (pot->get_name() == LJ || pot->get_name() == TM)
    {
      VECTOR F;
      ARRAY<int> neighbours;
      for (int icell = 0; icell < cells.size(); icell++)
      {
	neighbours = cells[icell]->get_neighbours();
        cells[icell]->checked = TRUE;
        prn("Actual cell = ", cells[icell]->r0);
	prn("CHECKED ", icell);
        for (int ip = 0; ip < cells[icell]->particles.size(); ip++)
        {
          prn("Particle # = ", ip);
	  PARTICLE& pi = *(cells[icell]->particles[ip]);
// Check in the current cell
            for (int jp = ip+1; jp < cells[icell]->particles.size(); jp++)
            {
	      PARTICLE& pj = *(cells[icell]->particles[jp]);
              F = pot->get_force(&pi,&pj);
      	      pi.F += F;
              pj.F += -1.*F;
//o tmp
//              if (((pi.x-pj.x).norm()-pow(2.,1./6.)*pot->get_coef(1))/(pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
//		pi.color = 2; pj.color = 2;
//              }
              if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		pi.color = 2; pj.color = 2;
	      }
//x tmp
	    }
          
          for (int ig = 0; ig < neighbours.size(); ig++)
          {
	      if (cells[neighbours[ig]]->position==TOP_2D) prn("AAA top");
	      if (cells[neighbours[ig]]->position==TOP_LEFT_2D) prn("AAA top left"); 
	      if (cells[neighbours[ig]]->position==TOP_RIGHT_2D) prn("AAA top right"); 
	      if (cells[neighbours[ig]]->position==BOT_2D) prn("AAA bot"); 
	      if (cells[neighbours[ig]]->position==BOT_LEFT_2D) prn("AAA bot left"); 
	      if (cells[neighbours[ig]]->position==BOT_RIGHT_2D) prn("AAA bot right"); 
	      if (cells[neighbours[ig]]->position==LEFT_2D) prn("AAA left"); 
	      if (cells[neighbours[ig]]->position==RIGHT_2D) prn("AAA right"); 
	      if (cells[neighbours[ig]]->position==MID_2D) prn("AAA middle"); 	 
          }

// Check in neighbouring cells
//    Middle cells 
          if (cells[icell]->position == MID_2D)
          {
	    for (int in = 0; in < neighbours.size(); in++)
            {
	      prn("For middle cells --> in = ", cells[neighbours[in]]->r0);
	      if (!cells[neighbours[in]]->checked)
              {
		for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                {
             	  PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
             	  F = pot->get_force(&pi,&pj);
             	  pi.F += F;
             	  pj.F += -1.*F;
//o tmp
//                  if (((pi.x-pj.x).norm()-pow(2.,1./6.)*pot->get_coef(1))/(pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
//   		    pi.color = 2; pj.color = 2;
//                  }
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
          	}
	      }
            }
          }
//    Edge cells BOT LEFT
          else if (cells[icell]->position == BOT_LEFT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
	      prn("For bot left cells --> in = ", cells[neighbours[in]]->r0);
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == RIGHT_2D || cells[neighbours[in]]->position == BOT_RIGHT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
	prn("A");
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
//                  if (((pi.x-pj.x).norm()-pow(2.,1./6.)*pot->get_coef(1))/(pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
//   		    pi.color = 2; pj.color = 2;
//                  }
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
                else if (cells[neighbours[in]]->position == TOP_LEFT_2D || cells[neighbours[in]]->position == TOP_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
	prn("B");
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else if (cells[neighbours[in]]->position == TOP_RIGHT_2D) 
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
	prn("C");
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                  }
		}
              }
            }
          }
//    Edge cells LEFT
          else if (cells[icell]->position == LEFT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
	      prn("For left cells --> in = ", cells[neighbours[in]]->r0);
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == RIGHT_2D || cells[neighbours[in]]->position == BOT_RIGHT_2D || cells[neighbours[in]]->position == TOP_RIGHT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                  }
		}
              }
            }
          }
//    Edge cells TOP_LEFT
          else if (cells[icell]->position == TOP_LEFT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
	      prn("For top left cells --> in = ", cells[neighbours[in]]->r0);
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == RIGHT_2D || cells[neighbours[in]]->position == TOP_RIGHT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
                else if (cells[neighbours[in]]->position == BOT_LEFT_2D || cells[neighbours[in]]->position == BOT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else if (cells[neighbours[in]]->position == BOT_RIGHT_2D) 
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                  }
		}
              }
            }
          }
//    Edge cells BOT_2D
          else if (cells[icell]->position == BOT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
	      prn("For bottom cells --> in = ", cells[neighbours[in]]->r0);
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == TOP_2D || cells[neighbours[in]]->position == TOP_RIGHT_2D || cells[neighbours[in]]->position == TOP_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
                else
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                  }
                }
              }
            }
          }
//    Edge cells TOP_2D
          else if (cells[icell]->position == TOP_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
	      prn("For top cells --> in = ", cells[neighbours[in]]->r0);
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == BOT_2D || cells[neighbours[in]]->position == BOT_RIGHT_2D || cells[neighbours[in]]->position == BOT_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
                else
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                  }
                }
              }
            }
          }
//    Edge cells BOT RIGHT
          else if (cells[icell]->position == BOT_RIGHT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
	      prn("For top right cells --> in = ", cells[neighbours[in]]->r0);
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == LEFT_2D || cells[neighbours[in]]->position == BOT_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
                else if (cells[neighbours[in]]->position == TOP_RIGHT_2D || cells[neighbours[in]]->position == TOP_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else if (cells[neighbours[in]]->position == TOP_LEFT_2D) 
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    prn("AAA pi.x = ", pi.x);
                    prn("AAA pj.x = ", pj.x);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    prn("AAA after pj.x = ", pj.x);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                  }
		}
              }
            }
          }
//    Edge cells RIGHT
          else if (cells[icell]->position == RIGHT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
	      prn("For right cells --> in = ", cells[neighbours[in]]->r0);
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == LEFT_2D || cells[neighbours[in]]->position == BOT_LEFT_2D || cells[neighbours[in]]->position == TOP_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                  }
		}
              }
            }
          }
//    Edge cells TOP_RIGHT
          else if (cells[icell]->position == TOP_RIGHT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
	      prn("For top right cells --> in = ", cells[neighbours[in]]->r0);
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == LEFT_2D || cells[neighbours[in]]->position == TOP_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
                else if (cells[neighbours[in]]->position == BOT_RIGHT_2D || cells[neighbours[in]]->position == BOT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else if (cells[neighbours[in]]->position == BOT_LEFT_2D) 
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                  }
		}
              }
            }
          }

          if (pi.bc_f.norm()>0.)
	   pi.F += pi.bc_f;
        }
      }
      for (int icell = 0; icell < cells.size(); icell++)
        cells[icell]->checked = FALSE;
prn("Here");
    }
    else if (pot->get_name() == EAM)
    {
	// Michael
    } 
    else 
	ERROR("Implemented only for LJ and TM potential");
}
*/
void MD_INTEGRATOR::compF(ARRAY<CELL*>& cells, MD_POTENTIAL* pot, double& potential_energy, double& pressure) {
    if (pot->get_name() == LJ || pot->get_name() == TM || pot->get_name() == CONTACT) {
      VECTOR F;
      LIST<int> neighbours;
      for (int icell = 0; icell < cells.size(); icell++) {
	neighbours = cells[icell]->get_neighbours();
        cells[icell]->checked = TRUE;
        for (int ip = 0; ip < cells[icell]->particles.size(); ip++) {
	  PARTICLE& pi = *(cells[icell]->particles[ip]);
// Check in the current cell
            for (int jp = ip+1; jp < cells[icell]->particles.size(); jp++)
            {
	      PARTICLE& pj = *(cells[icell]->particles[jp]);
              F = pot->get_force(&pi,&pj);
	      potential_energy += pot->get_potential(&pi,&pj);
              pressure += (F|(pi.x-pj.x));
      	      pi.F += F;
              pj.F += -1.*F;
	    }
          

// Check in neighbouring cells
//    Middle cells 
          //if (1 || cells[icell]->position == MID_2D)
          if ( cells[icell]->position == MID_2D)
          {
	    for (int in = 0; in < neighbours.size(); in++)
            {
	      if (!cells[neighbours[in]]->checked)
              {
		for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                {
             	  PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
             	  F = pot->get_force(&pi,&pj);
	          potential_energy += pot->get_potential(&pi,&pj);
                  pressure += (F|(pi.x-pj.x));
             	  pi.F += F;
             	  pj.F += -1.*F;
          	}
	      }
            }
          }
//    Edge cells BOT LEFT
          else if (cells[icell]->position == BOT_LEFT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == RIGHT_2D || cells[neighbours[in]]->position == BOT_RIGHT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
                else if (cells[neighbours[in]]->position == TOP_LEFT_2D || cells[neighbours[in]]->position == TOP_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else if (cells[neighbours[in]]->position == TOP_RIGHT_2D) 
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                  }
		}
              }
            }
          }
//    Edge cells LEFT
          else if (cells[icell]->position == LEFT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == RIGHT_2D || cells[neighbours[in]]->position == BOT_RIGHT_2D || cells[neighbours[in]]->position == TOP_RIGHT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                  }
		}
              }
            }
          }
//    Edge cells TOP_LEFT
          else if (cells[icell]->position == TOP_LEFT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == RIGHT_2D || cells[neighbours[in]]->position == TOP_RIGHT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
                else if (cells[neighbours[in]]->position == BOT_LEFT_2D || cells[neighbours[in]]->position == BOT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else if (cells[neighbours[in]]->position == BOT_RIGHT_2D) 
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                  }
		}
              }
            }
          }
//    Edge cells BOT_2D
          else if (cells[icell]->position == BOT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == TOP_2D || cells[neighbours[in]]->position == TOP_RIGHT_2D || cells[neighbours[in]]->position == TOP_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
                else
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                  }
                }
              }
            }
          }
//    Edge cells TOP_2D
          else if (cells[icell]->position == TOP_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == BOT_2D || cells[neighbours[in]]->position == BOT_RIGHT_2D || cells[neighbours[in]]->position == BOT_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
                else
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                  }
                }
              }
            }
          }
//    Edge cells BOT RIGHT
          else if (cells[icell]->position == BOT_RIGHT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == LEFT_2D || cells[neighbours[in]]->position == BOT_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
                else if (cells[neighbours[in]]->position == TOP_RIGHT_2D || cells[neighbours[in]]->position == TOP_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else if (cells[neighbours[in]]->position == TOP_LEFT_2D) 
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                  }
		}
              }
            }
          }
//    Edge cells RIGHT
          else if (cells[icell]->position == RIGHT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == LEFT_2D || cells[neighbours[in]]->position == BOT_LEFT_2D || cells[neighbours[in]]->position == TOP_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                  }
		}
              }
            }
          }
//    Edge cells TOP_RIGHT
          else if (cells[icell]->position == TOP_RIGHT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
	      prn("For top right cells --> in = ", cells[neighbours[in]]->r0);
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == LEFT_2D || cells[neighbours[in]]->position == TOP_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
                else if (cells[neighbours[in]]->position == BOT_RIGHT_2D || cells[neighbours[in]]->position == BOT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else if (cells[neighbours[in]]->position == BOT_LEFT_2D) 
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
	            potential_energy += pot->get_potential(&pi,&pj);
                    pressure += (F|(pi.x-pj.x));
                    pi.F += F;
                    pj.F += -1.*F;
                  }
		}
              }
            }
          }
          if (pi.bc_f.norm()>0.) {
	   pi.F += pi.bc_f;
	  }
        }
      }
      for (int icell = 0; icell < cells.size(); icell++)
        cells[icell]->checked = FALSE;
    }
    else if (pot->get_name() == EAM)
    {
	// Michael
    } 
    else 
	ERROR("Implemented only for LJ and TM potential");
}
// The same function but without potential energy
void MD_INTEGRATOR::compF(ARRAY<CELL*>& cells, MD_POTENTIAL* pot) {
    if (pot->get_name() == LJ || pot->get_name() == TM || pot->get_name() == CONTACT) {
      VECTOR F;
      LIST<int> neighbours;
      for (int icell = 0; icell < cells.size(); icell++) {
	neighbours = cells[icell]->get_neighbours();
        cells[icell]->checked = TRUE;
        for (int ip = 0; ip < cells[icell]->particles.size(); ip++) {
	  PARTICLE& pi = *(cells[icell]->particles[ip]);
// Check in the current cell
            for (int jp = ip+1; jp < cells[icell]->particles.size(); jp++)
            {
	      PARTICLE& pj = *(cells[icell]->particles[jp]);
              F = pot->get_force(&pi,&pj);
      	      pi.F += F;
              pj.F += -1.*F;
//o tmp
/*
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
*/
//x tmp
	    }
          

// Check in neighbouring cells
//    Middle cells 
          //if (1 || cells[icell]->position == MID_2D)
          if ( cells[icell]->position == MID_2D)
          {
	    for (int in = 0; in < neighbours.size(); in++)
            {
	      if (!cells[neighbours[in]]->checked)
              {
		for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                {
             	  PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
             	  F = pot->get_force(&pi,&pj);
             	  pi.F += F;
             	  pj.F += -1.*F;
          	}
	      }
            }
          }
//    Edge cells BOT LEFT
          else if (cells[icell]->position == BOT_LEFT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == RIGHT_2D || cells[neighbours[in]]->position == BOT_RIGHT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
                else if (cells[neighbours[in]]->position == TOP_LEFT_2D || cells[neighbours[in]]->position == TOP_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else if (cells[neighbours[in]]->position == TOP_RIGHT_2D) 
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                  }
		}
              }
            }
          }
//    Edge cells LEFT
          else if (cells[icell]->position == LEFT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == RIGHT_2D || cells[neighbours[in]]->position == BOT_RIGHT_2D || cells[neighbours[in]]->position == TOP_RIGHT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                  }
		}
              }
            }
          }
//    Edge cells TOP_LEFT
          else if (cells[icell]->position == TOP_LEFT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == RIGHT_2D || cells[neighbours[in]]->position == TOP_RIGHT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
                else if (cells[neighbours[in]]->position == BOT_LEFT_2D || cells[neighbours[in]]->position == BOT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else if (cells[neighbours[in]]->position == BOT_RIGHT_2D) 
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                  }
		}
              }
            }
          }
//    Edge cells BOT_2D
          else if (cells[icell]->position == BOT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == TOP_2D || cells[neighbours[in]]->position == TOP_RIGHT_2D || cells[neighbours[in]]->position == TOP_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
                else
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                  }
                }
              }
            }
          }
//    Edge cells TOP_2D
          else if (cells[icell]->position == TOP_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == BOT_2D || cells[neighbours[in]]->position == BOT_RIGHT_2D || cells[neighbours[in]]->position == BOT_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
                else
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                  }
                }
              }
            }
          }
//    Edge cells BOT RIGHT
          else if (cells[icell]->position == BOT_RIGHT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == LEFT_2D || cells[neighbours[in]]->position == BOT_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
                else if (cells[neighbours[in]]->position == TOP_RIGHT_2D || cells[neighbours[in]]->position == TOP_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else if (cells[neighbours[in]]->position == TOP_LEFT_2D) 
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                  }
		}
              }
            }
          }
//    Edge cells RIGHT
          else if (cells[icell]->position == RIGHT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == LEFT_2D || cells[neighbours[in]]->position == BOT_LEFT_2D || cells[neighbours[in]]->position == TOP_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                  }
		}
              }
            }
          }
//    Edge cells TOP_RIGHT
          else if (cells[icell]->position == TOP_RIGHT_2D)
          {
            for (int in = 0; in < neighbours.size(); in++)
            {
	      prn("For top right cells --> in = ", cells[neighbours[in]]->r0);
              if (!cells[neighbours[in]]->checked)
              {
                if (cells[neighbours[in]]->position == LEFT_2D || cells[neighbours[in]]->position == TOP_LEFT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                  }
                }
                else if (cells[neighbours[in]]->position == BOT_RIGHT_2D || cells[neighbours[in]]->position == BOT_2D)
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
//                
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else if (cells[neighbours[in]]->position == BOT_LEFT_2D) 
                {
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    if (periodic_x)
                      pj.x[0] += (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] += (cells[icell]->size[1]*(cells[icell]->Ny));
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                    if (periodic_x)
                      pj.x[0] -= (cells[icell]->size[0]*(cells[icell]->Nx));
                    if (periodic_y)
                      pj.x[1] -= (cells[icell]->size[1]*(cells[icell]->Ny));
                  }
                }
		else
		{
                  for (int jp = 0; jp < cells[neighbours[in]]->particles.size(); jp++)
                  {
                    PARTICLE& pj = *(cells[neighbours[in]]->particles[jp]);
                    F = pot->get_force(&pi,&pj);
                    pi.F += F;
                    pj.F += -1.*F;
//o tmp
                  if (fabs(((pi.x-pj.x).norm()-sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))/(sqrt(2)*pow(2.,1./6.)*pot->get_coef(1))) < 0.05) {
		    pi.color = 2; pj.color = 2;
	          }
//x tmp
                  }
		}
              }
            }
          }
          if (pi.bc_f.norm()>0.) {
	   pi.F += pi.bc_f;
	  }
        }
      }
      for (int icell = 0; icell < cells.size(); icell++)
        cells[icell]->checked = FALSE;
    }
    else if (pot->get_name() == EAM)
    {
	// Michael
    } 
    else 
	ERROR("Implemented only for LJ and TM potential");
}



/*
void MD_INTEGRATOR::updateX(PARTICLE*& p, double dt)
{

}
void MD_INTEGRATOR::updateV(PARTICLE*& p, double dt)
{

}
*/
/*
void MD_INTEGRATOR::compV(ARRAY<CELL*>& cells, double dt) {
  for (int i = 0; i < cells.size(); i++) {
    for (int j = 0; j < cells[i]->particles.size(); j++) {
      if (cells[i]->particles[j]->bc_v.norm()==0.) {
        cells[i]->particles[j]->v += dt/(2*cells[i]->particles[j]->mat->mass)*(cells[i]->particles[j]->F + cells[i]->particles[j]->F_old);
      }
      else 
        cells[i]->particles[j]->v = cells[i]->particles[j]->bc_v; 
    }
  }
}
*/
void MD_INTEGRATOR::compV(ARRAY<CELL*>& cells, double dt, double& kinetic_energy) {
  for (int i = 0; i < cells.size(); i++)
  {
    for (int j = 0; j < cells[i]->particles.size(); j++)
    {
      if (cells[i]->particles[j]->bc_x.size() == 0. && cells[i]->particles[j]->bc_v.size() == 0.) 
      {
        cells[i]->particles[j]->v += dt/(2*cells[i]->particles[j]->mat->mass)*(cells[i]->particles[j]->F + cells[i]->particles[j]->F_old);
      }
      else if (cells[i]->particles[j]->bc_v.size() > 0)
        cells[i]->particles[j]->v = cells[i]->particles[j]->bc_v;
      else
        cells[i]->particles[j]->v = 0; 

      kinetic_energy += 0.5*pow((cells[i]->particles[j]->v).norm(),2.)*cells[i]->particles[j]->mat->mass;
    }
  }
}
// The same but without kinetic energy
void MD_INTEGRATOR::compV(ARRAY<CELL*>& cells, double dt) {
  for (int i = 0; i < cells.size(); i++) {
    for (int j = 0; j < cells[i]->particles.size(); j++) {
      if (cells[i]->particles[j]->bc_x.size() == 0. && cells[i]->particles[j]->bc_v.size() == 0.) {
        cells[i]->particles[j]->v += dt/(2*cells[i]->particles[j]->mat->mass)*(cells[i]->particles[j]->F + cells[i]->particles[j]->F_old);
      }
      else if (cells[i]->particles[j]->bc_v.size() > 0)
        cells[i]->particles[j]->v = cells[i]->particles[j]->bc_v;
      else
        cells[i]->particles[j]->v = 0; 
    }
  }
}
int MD_INTEGRATOR::escaping_node(VECTOR e) {
  if (e[0] < rmin[0])
   return 1;
  if (e[0] > rmax[0])
   return 2;
  if (e[1] < rmin[1])
   return 3;
  if (e[1] > rmax[1])
   return 4;
  return 0; 
}
void MD_INTEGRATOR::compX(ARRAY<CELL*>& cells, double dt) {

  for (int i = 0; i < cells.size(); i++)
  {
    for (int j = 0; j < cells[i]->particles.size(); j++)
    {
      if (cells[i]->particles[j]->bc_x.norm()==0.)
      {
        VECTOR tryit = cells[i]->particles[j]->v*dt + cells[i]->particles[j]->F*dt*dt/(2*cells[i]->particles[j]->mat->mass);
	if (has_rigid_bc) {
          int escape = escaping_node(cells[i]->particles[j]->x+tryit);
	  if (escape != 0) {
         }	
	 cells[i]->particles[j]->x += tryit;

	  VECTOR trypos;
          trypos.resize(2);
	  trypos = 0;
          if (escape == 1) {
             trypos[0] = 2*rmin[0]-2*cells[i]->particles[j]->x[0] - tryit[0];
             trypos[1] = -tryit[1];
	     cells[i]->particles[j]->v[0] *= -1;
          }
	  else if (escape == 2) {
             trypos[0] = 2*rmax[0]-2*cells[i]->particles[j]->x[0] - tryit[0];
             trypos[1] = -tryit[1];
	     cells[i]->particles[j]->v[0] *= -1;
          }
	  else if (escape == 3) {
             trypos[1] = 2*rmin[1]-2*cells[i]->particles[j]->x[1] - tryit[1];
             trypos[0] = -tryit[0];
	     cells[i]->particles[j]->v[1] *= -1;
          }
	  else if (escape == 4) {
             trypos[1] = 2*rmax[1]-2*cells[i]->particles[j]->x[1] - tryit[1];
             trypos[0] = -tryit[0];
	     cells[i]->particles[j]->v[1] *= -1;
          }

// Check for a consecutive violation of Rigid BC
   
          escape = escaping_node(cells[i]->particles[j]->x+trypos);
          if (escape == 1) {
             trypos[0] = 2*rmin[0]-2*cells[i]->particles[j]->x[0] - tryit[0];
             trypos[1] = -tryit[1];
             //cells[i]->particles[j]->x[0] = 2*rmin[0]-cells[i]->particles[j]->x[0] - tryit[0];
                            //cells[i]->particles[j]->x[1] +=  - tryit[1];
                                           cells[i]->particles[j]->v[0] *= -1;
          }
          else if (escape == 2) {
             trypos[0] = 2*rmax[0]-2*cells[i]->particles[j]->x[0] - tryit[0];
             trypos[1] = -tryit[1];
             //cells[i]->particles[j]->x[0] = 2*rmax[0]-cells[i]->particles[j]->x[0] - tryit[0];
                            //cells[i]->particles[j]->x[1] +=  - tryit[1];
                                           cells[i]->particles[j]->v[0] *= -1;
          }
          else if (escape == 3) {
             trypos[1] = 2*rmin[1]-2*cells[i]->particles[j]->x[1] - tryit[1];
             trypos[0] = -tryit[0];
             //cells[i]->particles[j]->x[1] = 2*rmin[1]-cells[i]->particles[j]->x[1] - tryit[1];
                            //cells[i]->particles[j]->x[0] +=  - tryit[0];
                                           cells[i]->particles[j]->v[1] *= -1;
          }
          else if (escape == 4) {
             trypos[1] = 2*rmax[1]-2*cells[i]->particles[j]->x[1] - tryit[1];
             trypos[0] = -tryit[0];
             //cells[i]->particles[j]->x[1] = 2*rmax[1]-cells[i]->particles[j]->x[1] - tryit[1];
                            //cells[i]->particles[j]->x[0] +=  -tryit[0];
                                           cells[i]->particles[j]->v[1] *= -1;
          }

          cells[i]->particles[j]->x += trypos;
        }
        else {
          cells[i]->particles[j]->x += tryit;
        }
	if ((cells[i]->particles[j]->F*dt*dt/(2*cells[i]->particles[j]->mat->mass)+cells[i]->particles[j]->v*dt).norm() > cells[i]->size.norm())
	  ERROR("Divergence :: incremental displacement is higher than the cell size");
      }
      else
        cells[i]->particles[j]->x = cells[i]->particles[j]->bc_x; 
      cells[i]->particles[j]->F_old = cells[i]->particles[j]->F;
      cells[i]->particles[j]->F = 0;
    }
  }
}
void MD_INTEGRATOR::redistribute_particles(ARRAY<CELL*>& cells)
{
  VECTOR if_in;
  LIST<PARTICLE*> p_to_move;
  LIST<VECTOR> where_move;
  int move_to_cell,dim=cells[0]->size.size();

  for (int i = 0; i < cells.size(); i++)
  {
    p_to_move.resize(0);
    where_move.resize(0);
    for (int j = 0; j < cells[i]->particles.size(); j++)
    {
      if_in = cells[i]->if_in(cells[i]->particles[j]->x);
      if (if_in.norm() != 0)
      {
	p_to_move.add(cells[i]->particles[j]);
	where_move.add(if_in);
      }	
    }
// remove and add particles
    int Nx = cells[0]->Nx,
	Ny = cells[0]->Ny,
        Nz = cells[0]->Nz;
    double Sx = cells[0]->size[0],
	   Sy = cells[0]->size[1],
	   Sz = 0;
    if (dim > 2)
      Sz = cells[0]->size[2];
   
    for (int j = 0; j < p_to_move.size(); j++)
    {
      move_to_cell = cells[i]->find_neighbour(where_move[j]); 
      cells[i]->particles.suppress_item(p_to_move[j]);
      if (dim == 2 && move_to_cell >= 0)
      {
        if (periodic_x)
        {
	  if ((cells[i]->position == RIGHT_2D || cells[i]->position == TOP_RIGHT_2D || cells[i]->position == BOT_RIGHT_2D) && where_move[j][0] > 0.) {
	    p_to_move[j]->x[0] -= (cells[i]->size[0]*cells[i]->Nx);
	  }
	  else if ((cells[i]->position == LEFT_2D || cells[i]->position == TOP_LEFT_2D || cells[i]->position == BOT_LEFT_2D) && where_move[j][0] < 0.)
	    p_to_move[j]->x[0] += (cells[i]->size[0]*cells[i]->Nx);
        }
        if (periodic_y)
        {
	  if ((cells[i]->position == TOP_2D || cells[i]->position == TOP_RIGHT_2D || cells[i]->position == TOP_LEFT_2D) && where_move[j][1] > 0.)
	    p_to_move[j]->x[1] -= (cells[i]->size[1]*cells[i]->Ny);
	  else if ((cells[i]->position == BOT_2D || cells[i]->position == BOT_RIGHT_2D || cells[i]->position == BOT_LEFT_2D) && where_move[j][1] < 0.)
	    p_to_move[j]->x[1] += (cells[i]->size[1]*cells[i]->Ny);
        }
      }
      else if (dim == 3)
	ERROR("position change has not been yet implemented in 3D");	
      if (move_to_cell >= 0)
        cells[move_to_cell]->particles.add(p_to_move[j]);	
    }
  }	
}
int MD_INTEGRATOR::solve_step(ARRAY<CELL*>& cells, MD_POTENTIAL* pot, double dt)
{
  if (name == SV)
  {
    compX(cells,dt); // constant
    redistribute_particles(cells); // constant
    compF(cells,pot); // need to change for different potentials
    compV(cells,dt); // constant
  }
  else
    ERROR("Unknown integrator");

  return 0;
}
int MD_INTEGRATOR::solve_step(ARRAY<CELL*>& cells, MD_POTENTIAL* pot, double dt, bool compute_energy, double& kinetic_energy, double& potential_energy, double& pressure, CALC_TIMER_COUNTER& tc)
{
  if (name == SV) {
    kinetic_energy = 0;
    potential_energy = 0;
    pressure = 0;
    tc.start_time("MD compX");
    compX(cells,dt); // constant
    tc.stop_time("MD compX");

    tc.start_time("MD redistribute");
    redistribute_particles(cells); // constant
    tc.stop_time("MD redistribute");
//    if (compute_energy) {
      tc.start_time("MD compF");
      compF(cells,pot,potential_energy,pressure); // need to change for different potentials
      tc.stop_time("MD compF");
      tc.start_time("MD compV");
      compV(cells,dt,kinetic_energy); // constant
      tc.stop_time("MD compV");
/*
    }
    else {
      compF(cells,pot); // need to change for different potentials
      compV(cells,dt); // constant
    }
*/
  }
  else
    ERROR("Unknown integrator");

  return 0;
}

