#ifndef __MD_POTENTIAL__
#define __MD_POTENTIAL__

#include <MD_Material.h>
#include <Particle.h>
#include <Cell.h>

namespace ZSET{
  using namespace ZSET;

 
class MD_POTENTIAL
{
protected:
  STRING name;
  ARRAY<double> param, coef, mix;
  double alpha;
  bool initialized,if_mix_rule;
  ARRAY<PARTICLE*> ap;
  ARRAY<ARRAY<double> > damage;
public:
  MD_POTENTIAL() {}// initialized = FALSE; }
  MD_POTENTIAL(STRING n) { 
	name = n; 
	if (name == LJ) 
		param.resize(2); 
	else if (name == TM) 
		param.resize(4); 
	else if (name == CONTACT)
		param.resize(2);
	else 
	  ERROR("Unknown potential <"+name+">"); 
	ap.resize(2);
  }
//  MD_POTENTIAL(STRING n, ARRAY<double> p) { name = n; param = p; coef = c; initialized = TRUE; }
 ~MD_POTENTIAL() {}

 void set_param(int i,double v)  { param[i-1] = v; }
 void initialize(MD_MATERIAL* mat);
 void initialize();
 STRING get_name() { return name; }

 void   precompute_links(ARRAY<CELL*>& cells, int psize);
 double get_potential(ARRAY<PARTICLE*> p);
 double get_potential(PARTICLE* p1, PARTICLE* p2);
 VECTOR get_force(ARRAY<PARTICLE*> p); // get force which acts on the first particle p[0]
 VECTOR get_force(PARTICLE* p1, PARTICLE* p2); // get force which acts on the first p1
 ARRAY<double> mixing_rule(MD_MATERIAL* mat1, MD_MATERIAL* mat2);
 void set_mix_rule(ARRAY<double> parameters);
//?tmp?
 double get_coef(int i) {return coef[i];}
 void scale_parameters(MULTIPLIERS m);
};

}

#endif

